MsWrdStruct::Paragraph Struct Reference documentation

Public Member Functions | Public Attributes | Friends | List of all members
MsWrdStruct::Paragraph Struct Referencefinal

the paragraph structure of a Microsoft Word file More...

`#include <MsWrdStruct.hxx>`

Inheritance diagram for MsWrdStruct::Paragraph:

## Public Member Functions
| Paragraph (int version)
| Constructor. More...
| Paragraph (Paragraph const &)=default
Paragraph & | operator= (Paragraph const &)=default
Paragraph & | operator= (Paragraph &&)=default
| ~Paragraph () final
| destructor More...
void | insert (Paragraph const &para, bool insertModif=true)
| insert the new values More...
bool | read (MWAWInputStreamPtr &input, long endPos)
| try to read a data More...
void | updateParagraphToFinalState (Paragraph const *style=nullptr)
| update the paragraph to obtain the final paragraph More...
bool | getFont (Font &font, Font const *styleFont=nullptr) const
| returns the font which correspond to the paragraph if possible More...
bool | inTable () const
| returns true if we are in table More...
void | print (std::ostream &o, MWAWFontConverterPtr converter) const
| operator<< More...
int | getNumLines () const
| returns the number of line stored in m_info or -1 More...
Public Member Functions inherited from MWAWParagraph
| MWAWParagraph ()
| constructor More...
| MWAWParagraph (MWAWParagraph const &)=default
MWAWParagraph & | operator= (MWAWParagraph const &)=default
MWAWParagraph & | operator= (MWAWParagraph &&)=default
virtual | ~MWAWParagraph ()
| destructor More...
bool | operator== (MWAWParagraph const &p) const
| operator== More...
bool | operator!= (MWAWParagraph const &p) const
| operator!= More...
int | cmp (MWAWParagraph const &p) const
| a comparison function More...
double | getMarginsWidth () const
| return the paragraph margin width (in inches) More...
bool | hasBorders () const
| check if the paragraph has some borders More...
bool | hasDifferentBorders () const
| check if the paragraph has different borders More...
void | resizeBorders (size_t newSize)
| a function used to resize the borders list ( adding empty borders if needed ) More...
void | setInterline (double value, librevenge::RVNGUnit unit, LineSpacingType type=Fixed)
| set the interline More...
void | addTo (librevenge::RVNGPropertyList &propList, bool inTable) const
| add to the propList More...
void | insert (MWAWParagraph const &para)
| insert the set values of para in the actual paragraph More...

## Public Attributes
int | m_version
| the file version More...
MWAWVariable< int > | m_styleId
| the style id (if known) More...
MWAWVariable< double > | m_interline
| the interline if set More...
std::vector< float > | m_deletedTabs
| the delete tabulation More...
MWAWVariable< ParagraphInfo > | m_info
| the dimension More...
MWAWVariable< Font > | m_font
| the font More...
MWAWVariable< Font > | m_modFont
| font (modifier) More...
MWAWVariable< Section > | m_section
| the section More...
MWAWVariable< MWAWBorder > | m_bordersStyle
| the border style ( old v3) More...
MWAWVariable< bool > | m_inCell
| a cell/textbox More...
MWAWVariable< bool > | m_tableDef
| a table flag More...
MWAWVariable< Table > | m_table
| the table More...
Public Attributes inherited from MWAWParagraph
MWAWVariable< double > | m_margins [3]
| the margins More...
MWAWVariable< librevenge::RVNGUnit > | m_marginsUnit
| the margins INCH, ... More...
MWAWVariable< double > | m_spacings [3]
| the line spacing More...
MWAWVariable< librevenge::RVNGUnit > | m_spacingsInterlineUnit
| the interline unit PERCENT or INCH, ... More...
MWAWVariable< LineSpacingType > | m_spacingsInterlineType
| the interline type: fixed, atLeast, ... More...
MWAWVariable< std::vector< MWAWTabStop > > | m_tabs
| the tabulations More...
MWAWVariable< bool > | m_tabsRelativeToLeftMargin
| true if the tabs are relative to left margin, false if there are relative to the page margin (default) More...
MWAWVariable< Justification > | m_justify
| the justification More...
MWAWVariable< int > | m_breakStatus
| a list of bits: 0x1 (unbreakable), 0x2 (do not break after) More...
MWAWVariable< libmwaw::WritingMode > | m_writingMode
| the writing mode More...
MWAWVariable< int > | m_listLevelIndex
| the actual level index More...
MWAWVariable< int > | m_listId
| the list id (if know ) More...
MWAWVariable< int > | m_listStartValue
| the list start value (if set ) More...
MWAWVariable< MWAWListLevel > | m_listLevel
| the actual level More...
MWAWVariable< MWAWColor > | m_backgroundColor
| the background color More...
std::vector< MWAWVariable< MWAWBorder > > | m_borders
| list of border ( order MWAWBorder::Pos) More...
MWAWVariable< int > | m_dropNumCharacters
| the drop number character More...
MWAWVariable< int > | m_dropNumLines
| the drop number of lines More...
std::string | m_styleName
| the style name More...
std::string | m_extra
| a string to store some errors More...

## Friends
std::ostream & | operator<< (std::ostream &o, Paragraph const &ind)
| operator<< More...

## Additional Inherited Members
Public Types inherited from MWAWParagraph
enum | { NoBreakBit = 0x1 , NoBreakWithNextBit =0x2 }
| some bit use to defined the break status More...
enum | Justification { JustificationLeft , JustificationFull , JustificationCenter , JustificationRight , JustificationFullAllLines }
| an enum used to defined the paragraph justification: left, center, right, full ... More...
enum | LineSpacingType { Fixed , AtLeast }
| the line spacing type: fixed or at least More...

## Detailed Description

the paragraph structure of a Microsoft Word file

## Constructor & Destructor Documentation

## ◆ Paragraph() [1/2]

MsWrdStruct::Paragraph::Paragraph | ( | int | version | ) |
| inlineexplicit

Constructor.

## ◆ Paragraph() [2/2]

MsWrdStruct::Paragraph::Paragraph | ( | Paragraph const & |  | ) |
| default

## ◆ ~Paragraph()

MsWrdStruct::Paragraph::~Paragraph | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ getFont()

bool MsWrdStruct::Paragraph::getFont | ( | Font & | font,
|  | Font const * | styleFont = `nullptr`
| ) |  | const

returns the font which correspond to the paragraph if possible

Referenced by MsWrdText::prepareFontProperties().

## ◆ getNumLines()

int MsWrdStruct::Paragraph::getNumLines | ( |  | ) | const
| inline

returns the number of line stored in m_info or -1

## ◆ insert()

void MsWrdStruct::Paragraph::insert | ( | Paragraph const & | para,
|  | bool | insertModif = `true`
| ) |  |

insert the new values

Referenced by MsWrdText::prepareParagraphProperties(), and MsWrdText::prepareTableLimits().

## ◆ inTable()

bool MsWrdStruct::Paragraph::inTable | ( |  | ) | const
| inline

returns true if we are in table

Referenced by MsWrdText::prepareParagraphProperties().

## ◆ operator=() [1/2]

Paragraph & MsWrdStruct::Paragraph::operator= | ( | Paragraph && |  | ) |
| default

## ◆ operator=() [2/2]

Paragraph & MsWrdStruct::Paragraph::operator= | ( | Paragraph const & |  | ) |
| default

## ◆ print()

void MsWrdStruct::Paragraph::print | ( | std::ostream & | o,
|  | MWAWFontConverterPtr | converter
| ) |  | const

operator<<

Referenced by MsWrdText::prepareData(), MsWrdTextStyles::readPLC(), MsWrdTextStyles::readPropertyModifier(), MsWrdTextStyles::readStylesParagraph(), and MsWrdTextStyles::readTextStructList().

## ◆ read()

bool MsWrdStruct::Paragraph::read | ( | MWAWInputStreamPtr & | input,
|  | long | endPos
| ) |  |

try to read a data

Referenced by MsWrdTextStyles::readParagraph().

## ◆ updateParagraphToFinalState()

void MsWrdStruct::Paragraph::updateParagraphToFinalState | ( | Paragraph const * | style = `nullptr` | ) |

update the paragraph to obtain the final paragraph

Referenced by MsWrdText::prepareParagraphProperties().

## Friends And Related Function Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | o,
|  | Paragraph const & | ind
| ) |  |
| friend

operator<<

## Member Data Documentation

## ◆ m_bordersStyle

MWAWVariable<MWAWBorder> MsWrdStruct::Paragraph::m_bordersStyle

the border style ( old v3)

Referenced by insert(), and read().

## ◆ m_deletedTabs

std::vector<float> MsWrdStruct::Paragraph::m_deletedTabs

the delete tabulation

Referenced by insert(), and read().

## ◆ m_font

MWAWVariable<Font> MsWrdStruct::Paragraph::m_font

the font

Referenced by getFont(), MsWrdTextStyles::getSectionFont(), insert(), print(), MsWrdTextStyles::readParagraph(), and MsWrdTextStyles::readStylesParagraph().

## ◆ m_inCell

MWAWVariable<bool> MsWrdStruct::Paragraph::m_inCell

a cell/textbox

Referenced by insert(), inTable(), and read().

## ◆ m_info

MWAWVariable<ParagraphInfo> MsWrdStruct::Paragraph::m_info

the dimension

Referenced by getNumLines(), insert(), and MsWrdTextStyles::readPLC().

## ◆ m_interline

MWAWVariable<double> MsWrdStruct::Paragraph::m_interline

the interline if set

Referenced by insert(), read(), and updateParagraphToFinalState().

## ◆ m_modFont

MWAWVariable<Font> MsWrdStruct::Paragraph::m_modFont

font (modifier)

Referenced by getFont(), insert(), print(), MsWrdTextStyles::readParagraph(), and MsWrdTextStyles::readStylesParagraph().

## ◆ m_section

MWAWVariable<Section> MsWrdStruct::Paragraph::m_section

the section

Referenced by insert(), read(), and MsWrdTextStyles::sendSection().

## ◆ m_styleId

MWAWVariable<int> MsWrdStruct::Paragraph::m_styleId

the style id (if known)

Referenced by insert(), MsWrdText::prepareParagraphProperties(), MsWrdText::prepareTableLimits(), read(), and MsWrdTextStyles::readPLC().

## ◆ m_table

MWAWVariable<Table> MsWrdStruct::Paragraph::m_table

the table

Referenced by insert(), MsWrdText::prepareTableLimits(), and read().

## ◆ m_tableDef

MWAWVariable<bool> MsWrdStruct::Paragraph::m_tableDef

a table flag

Referenced by insert(), MsWrdText::prepareTableLimits(), and read().

## ◆ m_version

int MsWrdStruct::Paragraph::m_version

the file version

Referenced by read().

The documentation for this struct was generated from the following files:

- MsWrdStruct.hxx
- MsWrdStruct.cxx